# coding: utf-8

"""
    Deep Search (DS) API

    API for Deep Search.  **WARNING**: This API is subject to change without warning!

    The version of the OpenAPI document: 3.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, SecretStr, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class GenAIOpenaiConfig(BaseModel):
    """
    Config for OpenAI API
    """ # noqa: E501
    genai_openai_api_key: SecretStr = Field(alias="GENAI_OPENAI_API_KEY")
    genai_openai_base_url: StrictStr = Field(alias="GENAI_OPENAI_BASE_URL")
    genai_openai_verify_tls: Optional[StrictBool] = Field(default=True, alias="GENAI_OPENAI_VERIFY_TLS")
    __properties: ClassVar[List[str]] = ["GENAI_OPENAI_API_KEY", "GENAI_OPENAI_BASE_URL", "GENAI_OPENAI_VERIFY_TLS"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GenAIOpenaiConfig from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GenAIOpenaiConfig from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "GENAI_OPENAI_API_KEY": obj.get("GENAI_OPENAI_API_KEY"),
            "GENAI_OPENAI_BASE_URL": obj.get("GENAI_OPENAI_BASE_URL"),
            "GENAI_OPENAI_VERIFY_TLS": obj.get("GENAI_OPENAI_VERIFY_TLS") if obj.get("GENAI_OPENAI_VERIFY_TLS") is not None else True
        })
        return _obj


