# coding: utf-8

"""
    Deep Search (DS) API

    API for Deep Search.  **WARNING**: This API is subject to change without warning!

    The version of the OpenAPI document: 3.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictBool
from typing import Any, ClassVar, Dict, List, Optional
from deepsearch.cps.apis.public_v2.models.backend import Backend
from deepsearch.cps.apis.public_v2.models.backend_settings import BackendSettings
from deepsearch.cps.apis.public_v2.models.merge_mode import MergeMode
from typing import Optional, Set
from typing_extensions import Self

class OcrSettings(BaseModel):
    """
    OcrSettings
    """ # noqa: E501
    enabled: Optional[StrictBool] = False
    backend: Optional[Backend] = None
    backend_settings: Optional[BackendSettings] = None
    merge_mode: Optional[MergeMode] = None
    __properties: ClassVar[List[str]] = ["enabled", "backend", "backend_settings", "merge_mode"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of OcrSettings from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of backend
        if self.backend:
            _dict['backend'] = self.backend.to_dict()
        # override the default output from pydantic by calling `to_dict()` of backend_settings
        if self.backend_settings:
            _dict['backend_settings'] = self.backend_settings.to_dict()
        # override the default output from pydantic by calling `to_dict()` of merge_mode
        if self.merge_mode:
            _dict['merge_mode'] = self.merge_mode.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of OcrSettings from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "enabled": obj.get("enabled") if obj.get("enabled") is not None else False,
            "backend": Backend.from_dict(obj["backend"]) if obj.get("backend") is not None else None,
            "backend_settings": BackendSettings.from_dict(obj["backend_settings"]) if obj.get("backend_settings") is not None else None,
            "merge_mode": MergeMode.from_dict(obj["merge_mode"]) if obj.get("merge_mode") is not None else None
        })
        return _obj


