# coding: utf-8

"""
    Deep Search (DS) API

    API for Deep Search.  **WARNING**: This API is subject to change without warning!

    The version of the OpenAPI document: 3.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictBool
from typing import Any, ClassVar, Dict, List, Optional
from deepsearch.cps.apis.public_v2.models.ocr_options import OCROptions
from deepsearch.cps.apis.public_v2.models.table_structure_options import TableStructureOptions
from typing import Optional, Set
from typing_extensions import Self

class ProjectDataIndexConversionSettingsInput(BaseModel):
    """
    ProjectDataIndexConversionSettingsInput
    """ # noqa: E501
    ocr: Optional[OCROptions] = None
    table_structure: Optional[TableStructureOptions] = None
    generate_page_images: Optional[StrictBool] = True
    __properties: ClassVar[List[str]] = ["ocr", "table_structure", "generate_page_images"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ProjectDataIndexConversionSettingsInput from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of ocr
        if self.ocr:
            _dict['ocr'] = self.ocr.to_dict()
        # override the default output from pydantic by calling `to_dict()` of table_structure
        if self.table_structure:
            _dict['table_structure'] = self.table_structure.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ProjectDataIndexConversionSettingsInput from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "ocr": OCROptions.from_dict(obj["ocr"]) if obj.get("ocr") is not None else None,
            "table_structure": TableStructureOptions.from_dict(obj["table_structure"]) if obj.get("table_structure") is not None else None,
            "generate_page_images": obj.get("generate_page_images") if obj.get("generate_page_images") is not None else True
        })
        return _obj


