# coding: utf-8

"""
    Deep Search (DS) API

    API for Deep Search.  **WARNING**: This API is subject to change without warning!

    The version of the OpenAPI document: 3.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
from inspect import getfullargspec
import json
import pprint
import re  # noqa: F401
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Optional
from deepsearch.cps.apis.public_v2.models.semantic_ingest_source_private_data_collection import SemanticIngestSourcePrivateDataCollection
from deepsearch.cps.apis.public_v2.models.semantic_ingest_source_private_data_document import SemanticIngestSourcePrivateDataDocument
from deepsearch.cps.apis.public_v2.models.semantic_ingest_source_public_data_document import SemanticIngestSourcePublicDataDocument
from deepsearch.cps.apis.public_v2.models.semantic_ingest_source_url import SemanticIngestSourceUrl
from typing import Union, Any, List, TYPE_CHECKING, Optional, Dict
from typing_extensions import Literal, Self
from pydantic import Field

SOURCE4_ANY_OF_SCHEMAS = ["SemanticIngestSourcePrivateDataCollection", "SemanticIngestSourcePrivateDataDocument", "SemanticIngestSourcePublicDataDocument", "SemanticIngestSourceUrl"]

class Source4(BaseModel):
    """
    Source4
    """

    # data type: SemanticIngestSourceUrl
    anyof_schema_1_validator: Optional[SemanticIngestSourceUrl] = None
    # data type: SemanticIngestSourcePublicDataDocument
    anyof_schema_2_validator: Optional[SemanticIngestSourcePublicDataDocument] = None
    # data type: SemanticIngestSourcePrivateDataDocument
    anyof_schema_3_validator: Optional[SemanticIngestSourcePrivateDataDocument] = None
    # data type: SemanticIngestSourcePrivateDataCollection
    anyof_schema_4_validator: Optional[SemanticIngestSourcePrivateDataCollection] = None
    if TYPE_CHECKING:
        actual_instance: Optional[Union[SemanticIngestSourcePrivateDataCollection, SemanticIngestSourcePrivateDataDocument, SemanticIngestSourcePublicDataDocument, SemanticIngestSourceUrl]] = None
    else:
        actual_instance: Any = None
    any_of_schemas: List[str] = Field(default=Literal["SemanticIngestSourcePrivateDataCollection", "SemanticIngestSourcePrivateDataDocument", "SemanticIngestSourcePublicDataDocument", "SemanticIngestSourceUrl"])

    model_config = {
        "validate_assignment": True,
        "protected_namespaces": (),
    }

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_anyof(cls, v):
        instance = Source4.model_construct()
        error_messages = []
        # validate data type: SemanticIngestSourceUrl
        if not isinstance(v, SemanticIngestSourceUrl):
            error_messages.append(f"Error! Input type `{type(v)}` is not `SemanticIngestSourceUrl`")
        else:
            return v

        # validate data type: SemanticIngestSourcePublicDataDocument
        if not isinstance(v, SemanticIngestSourcePublicDataDocument):
            error_messages.append(f"Error! Input type `{type(v)}` is not `SemanticIngestSourcePublicDataDocument`")
        else:
            return v

        # validate data type: SemanticIngestSourcePrivateDataDocument
        if not isinstance(v, SemanticIngestSourcePrivateDataDocument):
            error_messages.append(f"Error! Input type `{type(v)}` is not `SemanticIngestSourcePrivateDataDocument`")
        else:
            return v

        # validate data type: SemanticIngestSourcePrivateDataCollection
        if not isinstance(v, SemanticIngestSourcePrivateDataCollection):
            error_messages.append(f"Error! Input type `{type(v)}` is not `SemanticIngestSourcePrivateDataCollection`")
        else:
            return v

        if error_messages:
            # no match
            raise ValueError("No match found when setting the actual_instance in Source4 with anyOf schemas: SemanticIngestSourcePrivateDataCollection, SemanticIngestSourcePrivateDataDocument, SemanticIngestSourcePublicDataDocument, SemanticIngestSourceUrl. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Dict[str, Any]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        # anyof_schema_1_validator: Optional[SemanticIngestSourceUrl] = None
        try:
            instance.actual_instance = SemanticIngestSourceUrl.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
             error_messages.append(str(e))
        # anyof_schema_2_validator: Optional[SemanticIngestSourcePublicDataDocument] = None
        try:
            instance.actual_instance = SemanticIngestSourcePublicDataDocument.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
             error_messages.append(str(e))
        # anyof_schema_3_validator: Optional[SemanticIngestSourcePrivateDataDocument] = None
        try:
            instance.actual_instance = SemanticIngestSourcePrivateDataDocument.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
             error_messages.append(str(e))
        # anyof_schema_4_validator: Optional[SemanticIngestSourcePrivateDataCollection] = None
        try:
            instance.actual_instance = SemanticIngestSourcePrivateDataCollection.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
             error_messages.append(str(e))

        if error_messages:
            # no match
            raise ValueError("No match found when deserializing the JSON string into Source4 with anyOf schemas: SemanticIngestSourcePrivateDataCollection, SemanticIngestSourcePrivateDataDocument, SemanticIngestSourcePublicDataDocument, SemanticIngestSourceUrl. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], SemanticIngestSourcePrivateDataCollection, SemanticIngestSourcePrivateDataDocument, SemanticIngestSourcePublicDataDocument, SemanticIngestSourceUrl]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


